<?php
//-----------------------------------
// 共通コンテンツ管理
function cms($form, $act="list", $menu, $id=null)
{
	$data["menu"] = $menu;

	if ($act == "") {
		$act = "list";
	}
	//
	$data["message"] = $form["message"];
	// 削除
	if ($act == "delete") {
		$id = $_REQUEST["id"];
		if ($id) {
			$info = Info::getData($id);
		}
		if ($info) {
			// 画像を削除
			$msg = get_infoitem($id);
			foreach ($form["input"]["items"] as $key => $val) {
				if ($val["type"] == "image") {
					if ($msg[$key]) {
						delete_image($msg[$key]);
					}
				}
				if ($val["type"] == "file") {
					if ($msg[$key]) {
						delete_image($msg[$key]);
					}
				}
			}
			// メッセージを削除
			save_infoitem($id, array());
			// 情報を削除
			Info::deleteData($id);
			$data["message"] = "削除しました。";
		} else {
			$data["message"] = "無効なデータです";
		}
		if ($form["list"])  {
			$act = "list";
		}
	}
	if ($act == "new") {
		foreach ($form["input"]["items"] as $key => $val) {
			if ($val["title"] == "") continue;
			unset($item);
			$item = $val;
			$item["name"] = $key;
			$item[$val["type"]] = "1";
			if ($val["value"]) {
				$item["value"] = $val["value"];	// 初期値
			}
			if ($val["type"] == "checkbox") {
				if ($val["list"]) {		// 複数
					unset($sel);
					foreach ($val["list"] as $key2 => $val2) {
						$key_name = $key . "_" . $key2;
						unset($opt);
						$opt["key"] = $key_name;
						$opt["value"] = $key2;
						$opt["name"] = $val2;
						$sel[] = $opt;
					}
					$item["list"] = $sel;
				} else {	// 単一
					if ($val["value"]) {
						$item["checked"] = "checked";
					}
					$item["value"] = $val["value"];
				}
			} else if ($val["type"] == "date_sel") {
				if ($_REQUEST[$key]) {
					$year = substr($_REQUEST[$key], 0, 4);
					$item["month" . substr($_REQUEST[$key], 5, 2)] = "selected";
					if ($val["type"] == "date_sel") {
						$item["day" . substr($_REQUEST[$key], 8, 2)] = "selected";
					}
				}
				// 年の選択範囲の設定
				if ($val["year_s"] || $val["year_e"]) {
					if (!$val["year_s"]) {
						$val["year_s"] = date('Y');
					}
					if (!$val["year_e"]) {
						$val["year_e"] = date('Y');
					}
					for ($y = $val["year_s"]; $y <= $val["year_e"]; $y++) {
						if ($y == $year) {
							$item["years"][] = array("value" => $y, "sel" => "selected");
						} else {
							$item["years"][] = array("value" => $y);
						}
					}
				} else {
					for ($y = date('Y'); $y <= date('Y') + 5; $y++) {
						if ($y == $year) {
							$item["years"][] = array("value" => $y, "sel" => "selected");
						} else {
							$item["years"][] = array("value" => $y);
						}
					}
				}
			} else if ($val["list"]) {
				$sel = array();
				foreach ($val["list"] as $key2 => $val2) {
					unset($opt);
					$opt["value"] = $key2;
					$opt["name"] = $val2;
					$sel[] = $opt;
				}
				$item["list"] = $sel;
			}
			// 選択・他テーブル参照
			if (($val["type"] == "select")&& $val["reference"]) {
				$item["list"] = reference_list($item["value"], $val["reference"]);
			}
			$list[] = $item;
		}
		$data["list"] = $list;
		$data["page_title"] = $form["title"] . "追加";
		$data["form"] = $form;
		$data["mode"] = "new";
		if ($form["list"])  {
			$data["list_menu"] = "1";
		}
		html_include($form["input"]["form"], $data);
		exit;
	}
	if ($act == "update") {
		$mode = $_REQUEST["mode"];
		$id = $_REQUEST["id"];
		// コンテンツをチェック＆保存
		unset($value);
		foreach ($form["input"]["items"] as $key => $val) {
			if ($val["title"] == "") continue;
			unset($item);
			$item = $val;
			$item["name"] = $key;
			$item[$val["type"]] = "1";
			if (($val["type"] == "image")||($val["type"] == "file")) {
				if ($_FILES[$key]["name"]) {
					// 以前の画像があれば
					if ($_REQUEST[$key . "_old"]) {
						delete_image($_REQUEST[$key . "_old"]);
					}
					$img_id = save_image($_FILES[$key], $_REQUEST[$key . "_text"]);
					if ($img_id) {
						$value[$key] = $img_id;
					} else {
						$msg[$key] = $_FILES[$key]["name"] . "は保存できませんでした。画像は" . ini_get("upload_max_filesize") . "バイト以内にしてください。";
						$item["message"] = $msg[$key];
					}
				} else if ($_REQUEST[$key . "_old"]) {
					if ($_REQUEST[$key . "_del"]) {
						delete_image($_REQUEST[$key . "_old"]);	// 画像は削除
						$value[$key] = array();
					} else {
						$value[$key] = $_REQUEST[$key . "_old"];	// 前回の画像のまま
						$value[$key . "_text"] = $_REQUEST[$key . "_text"];
						$upd["title"] = $_REQUEST[$key . "_text"];
						Image::updateData($_REQUEST[$key . "_old"], $upd);	// コメント更新
					}
				}
			} else if (($val["type"] == "checkbox")&&($val["list"])) {		// 複数
				$v = array();
				foreach ($val["list"] as $key2 => $val2) {
					$key_name = $key . "_" . $key2;
					if ($_REdQUEST[$key_name]) {
						$v[] = $_REQUEST[$key_name];
					}
				}
				$value[$key] = $v;	// mydb.incの配列保存機能使用
			} else if ($val["type"] == "date_sel") {
				$y = $_REQUEST[$key . "_year"];
				$m = $_REQUEST[$key . "_month"];
				$d = $_REQUEST[$key . "_day"];
				if ($y || $m || $d) {
					if ($y && $m && $d) {
						if (checkdate ($m, $d, $y)) {
							$value[$key] = sprintf("%04d-%02d-%02d", $y, $m, $d);
						} else {
							$msg[$key] = "日付が間違っています";
							$item["message"] = $msg[$key];
						}
					} else {
						$msg[$key] = "年月日全て入力してください";
						$item["message"] = $msg[$key];
					}
				} else {
					$value[$key] = array();
				}
			} else {
				if ($_REQUEST[$key]) {
					$value[$key] = $_REQUEST[$key];
				} else {
					$value[$key] = "";
				}
			}
			if ($val["list"]) {
				$sel = array();
				foreach ($val["list"] as $key2 => $val2) {
					unset($opt);
					$opt["value"] = $key2;
					$opt["name"] = $val2;
					if ($key2 == $value[$key]) {
						if ($val["type"] == "select") {
							$opt["sel"] = "selected";
						} else {
							$opt["sel"] = "checked";
						}
					}
					$sel[] = $opt;
				}
				$item["list"] = $sel;
			}
			// エラーチェック関数
			if ($val["check"]) {
				$m = call_user_func($val["check"], $id, $value[$key]);
				if ($m) {
					$item["message"] = $m;
					$msg[$key] = $item["message"];
				}
			}
			if ($val["require"] && ($value[$key] == "")) {
				$item["message"] = "入力してください";
				$msg[$key] = "入力してください";
			}
			$item["value"] = $value[$key];
			$list[] = $item;
		}
		if ($msg) {
			// エラーなら再修正
			$data["form"] = $form;
			$data["mode"] = "new";
			$data["list"] = $list;
			$data["id"] = $id;
			$data["page_title"] = $form["title"] . "編集";
			//$data["mode"] = "edit";
			html_include($form["input"]["form"], $data);
			exit;
		}
		// 公開、順序情報を設定
		if (isset($_REQUEST["open"])) {
			$rec["open"] = $_REQUEST["open"];
		} else {
			$rec["open"] = "1";
		}
		if ($_REQUEST["kind"]) {
			$rec["genre"] = $_REQUEST["kind"];
		} else if ($_REQUEST["group"]) {
			$rec["genre"] = $_REQUEST["group"];
		} else {
			$rec["genre"] = "0";
		}
		if ($_REQUEST["news_date"]) {
			$rec["date"] = $_REQUEST["news_date"];
		}
		if ($id) {
			// 更新の場合
			Info::updateData($id, $rec);
		} else {
			$rec["kind"] = $form["id"];
			$id = Info::addData($rec);
		}
		if ($id && $value) {
			save_infoitem($id, $value);
		} else {
			$data["message"] = "保存に失敗しました。";
		}
		$data["message"] = "保存しました。";
		//
		if ($form["list"])  {
			$act = "list";
		} else {
			$act = "edit";
		}
	}
	/* ページの追加、削除したらメニューを更新する */
	if (($_REQUEST["act"] == "@propaty_update")&&($_REQUEST["mode"] == "new")) {
		header("location:./?act=@propaty");
		exit;
	}
	if ($_REQUEST["act"] == "@propaty_delete") {
		header("location:./?act=@propaty");
		exit;
	}
	//
	if ($act == "edit") {
		unset($list);
		if (!$id) {
			$id = $_REQUEST["id"];
		}
		if ($id) {
			$info = Info::getData($id);
		}
		if ($info) {
			$msg = get_infoitem($id);
			if ($form["input"]["func"]) {
				$msg = call_user_func($form["input"]["func"], $id, $msg);
			}
			foreach ($form["input"]["items"] as $key => $val) {
				if ($val["title"] == "") continue;
				unset($item);
				$item = $val;
				$item["name"] = $key;
				$item[$val["type"]] = "1";
				if ($val["type"] == "display") {
					$item["value"] = $val["value"];
				}
				if (isset($msg[$key])) {
					if ($val["type"] == "fckeditor") {
						$item["value"] = ereg_replace("[\n\r]", "", $msg[$key]);
						$item["value"] = ereg_replace("'", "\\'", $item["value"]);
					} else if ($val["type"] == "text") {
						$item["value"] = htmlspecialchars($msg[$key]);
					} else {
						$item["value"] = $msg[$key];
					}
				}
				if ($val["type"] == "checkbox") {
					if ($val["list"]) {		// 複数
						$v = explode(",", $msg[$key]);
						unset($sel);
						foreach ($val["list"] as $key2 => $val2) {
							$key_name = $key . "_" . $key2;
							unset($opt);
							$opt["key"] = $key_name;
							$opt["value"] = $key2;
							$opt["name"] = $val2;
							if (in_array($key2, $v)) {
								$opt["sel"] = "checked";
							}
							$sel[] = $opt;
						}
						$item["list"] = $sel;
					} else {	// 単一
						if ($msg[$key]) {
							$item["checked"] = "checked";
						}
						$item["value"] = $val["value"];
					}
				} else if ($val["list"]) {
					$sel = array();
					foreach ($val["list"] as $key2 => $val2) {
						unset($opt);
						$opt["value"] = $key2;
						$opt["name"] = $val2;
						if ($key2 == $msg[$key]) {
							if ($val["type"] == "select") {
								$opt["sel"] = "selected";
							} else {
								$opt["sel"] = "checked";
							}
						}
						$sel[] = $opt;
					}
					$item["list"] = $sel;
				}
				if ($val["type"] == "date_sel") {
					if (($act == "edit")&&($msg[$key])) {
						$year = substr($msg[$key], 0, 4);
						$item["month" . substr($msg[$key], 5, 2)] = "selected";
						if ($val["type"] == "date_sel") {
							$item["day" . substr($msg[$key], 8, 2)] = "selected";
						}
					}
					if ($act == "update") {
						$year = $_REQUEST[$key . "_year"];
						$item["month" . $_REQUEST[$key . "_month"]] = "selected";
						if ($val["type"] == "date_sel") {
							$item["day" . $_REQUEST[$key . "_day"]] = "selected";
						}
					}
					// 年の選択範囲の設定
					if ($val["year_s"] || $val["year_e"]) {
						if (!$val["year_s"]) {
							$val["year_s"] = date('Y');
						}
						if (!$val["year_e"]) {
							$val["year_e"] = date('Y');
						}
						for ($y = $val["year_s"]; $y <= $val["year_e"]; $y++) {
							if ($y == $year) {
								$item["years"][] = array("value" => $y, "sel" => "selected");
							} else {
								$item["years"][] = array("value" => $y);
							}
						}
					} else {
						// 当年含めて5年（デフォルト）
						for ($y = date('Y'); $y < date('Y') + 5; $y++) {
							if ($y == $year) {
								$item["years"][] = array("value" => $y, "sel" => "selected");
							} else {
								$item["years"][] = array("value" => $y);
							}
						}
					}
				}
				// 選択・他テーブル参照
				if (($val["type"] == "select")&& $val["reference"]) {
					$item["value"] = $msg[$key];
					$item["list"] = reference_list($item["value"], $val["reference"]);
				}
				if (($val["type"] == "image")||($val["type"] == "file")||($val["type"] == "pdf")) {
					$img = Image::getData($item["value"]);
					$ary = explode("/", $img["filetype"]);
					if ($ary) {
						$item["type_" . $ary[0]] = $ary[0];	// image,videoなど
					}
					$item["filefile"] = $img["save_name"];
					$item["filename"] = $img["name"];
					$item["value_text"] = $img["title"];
				}
//				if (($val["type"] == "file")&&($item["value"])) {
//					$file = Image::getData($item["value"]);
//					if ($file) {
//						$item["filename"] = $file["name"];
//					}
//				}
				$list[] = $item;
			}
			$data["list"] = $list;
			$data["page_title"] = $form["title"] . "編集";
			$data["form"] = $form;
			$data["mode"] = "edit";
			$data["id"] = $id;
			if ($form["list"])  {
				$data["list_menu"] = "1";
			}
			html_include($form["input"]["form"], $data);
			exit;
		}
		$data["message"] = "無効なデータです";
		if ($form["list"])  {
			$act = "list";
		}
	}
	// 一覧
	if ($act == "list") {
		$page = $_REQUEST["page"];
		if (!$page) {
			$page = 0;
		}
		//
		$db = new Info();
		$db->search[] = array("field" => "kind", "value" => $form["id"], "cond" => "=");
//		$db->search[] = array("field" => "del_flag", "value" => "0", "cond" => "=");
		$db->limit = MAX_PAGE_LINE;	// 1ページの表示件数
		$count = $db->getCount();
		$pages = intval(($count + $db->limit - 1) / $db->limit);
		if ($pages > 1) {
			$data["pager"] = page_index2($page, $pages);
		}
		$db->page = $page;
		if ($form["list"]["order"]) {
			$db->order = $form["list"]["order"];
		}
		$list = $db->getList();
		if ($list) {
			$rownum = 1;
			foreach ($list as $val) {
				unset($item);
				if (($rownum & 1) == 0) {
					$item["rowclass"] = "even";
				} else {
					$item["rowclass"] = "odd";
				}
				$rownum++;
				$item["id"] = $val["info_id"];
				$item["items"][] = $val["info_id"];
				$msg = get_infoitem($val["info_id"]);
				foreach ($form["list"]["items"] as $key => $val2) {
					if (isset($msg[$key])) {
						if ($val2["values"]) {
							if (isset($val2["values"][$msg[$key]])) {
								$item["items"][] = $val2["values"][$msg[$key]];
							} else {
								$item["items"][] = "[" . $msg[$key] . "]";
							}
						} else if ($val2["value"]) {
							$item["items"][] = $val2["value"][$msg[$key]];
						} else if ($val2["reference"]) {
							$item["items"][] = reference($msg[$key], $val2["reference"]);
						} else {
							if ($val2["func"]) {
								$item["items"][] = call_user_func($val2["func"], $msg[$key]);
							} else {
								$item["items"][] = $msg[$key];
							}
						}
					} else {
						$item["items"][] = "";
					}
				}
				$item["items"][] = $val["reg_date"];
				$list_data[] = $item;
			}
			$data["list"] = $list_data;
		}
		// 見出し
		unset($item);
		$item["name"] = "info_id";
		$item["title"] = "ID";
		$data["title"][] = $item;
		foreach ($form["list"]["items"] as $key => $val) {
			unset($item);
			$item["name"] = $key;
			$item["title"] = $val["title"];
			$data["title"][] = $item;
		}
		unset($item);
		$item["name"] = "";
		$item["title"] = "";
		$data["title"][] = $item;
		//
		$data["page_title"] = $form["title"] . "一覧";
		$data["form"] = $form;
		html_include($form["list"]["form"], $data);
		exit;
	}
}
// 特定のテーブルのデータを参照
function reference($id, $reference)
{
	$val = call_user_func(array($reference["class"], "getData"), $id);
	return $val[$reference["field"]];
}
function reference_list($id, $reference)
{
	$list = array();
/* 空を付与する場合
	$opt["value"] = "";
	$opt["name"] = "";
	$list[] = $opt;
*/
	if ($reference["cond"]) {
		$cond = $reference["cond"];
	} else {
		$cond = array();
	}
	$ret = call_user_func(array($reference["class"], "findData"), $cond, array($reference["value"], $reference["name"]), false, $reference["order"]);
	if ($ret) {
		foreach ($ret as $val) {
			unset($opt);
			$opt["value"] = $val[$reference["value"]];
			$opt["name"] = $val[$reference["name"]];
			if ($opt["value"] == $id) {
				$opt["sel"] = "selected";
			}
			$list[] = $opt;
		}
	}
	return $list;
}
?>
