<?php
/*
 * ファイル、ディレクトリ参照処理
 *
 * dirsearch.html/filesearch.htmlを使用
 */
//require_once("lib/configure.inc");
//require_once("common.inc");

define("DIR_MAX", 10);

$act = $_REQUEST["act"];

if ($act == "dirsearch") {
	$dir = $_REQUEST["dir"];
	if ($dir == "") {
		$dir = getcwd();
		$dir = strtr($dir, "\\", "/");	// Windows対応
	}
	$page = $_REQUEST["page"];
	if ($page == "") {
		$page = "0";
	}
	$ary = explode("/", $dir);
	if ($ary[count($ary) - 1] == "..") {
		array_pop($ary);
		array_pop($ary);
		$dir = join("/" , $ary);
	}
	$h = opendir($dir);
	$list = array();
	while (($item = readdir($h))) {
		if (is_dir($dir . "/" . $item)) {
			if ($item != ".") {
				$list[] = $item;
			}
		}
	}
	closedir($h);
//	$data["list"] = scandir("./");
	if (count($list) > DIR_MAX) {
		$n = intval((count($list) + (DIR_MAX - 1)) / DIR_MAX);
		$data["pageng"] = page_index($page, $n);
		$pos = 0;
		$n = 0;
		foreach ($list as $val) {
			if ($pos >= ($page * DIR_MAX)) {
				$data["list"][] = $val;
				$n++;
				if ($n >= DIR_MAX) break;
			}
			$pos++;
		}
	} else {
		$data["list"] = $list;
	}
	$data["page"] = $page;
	$data["dir"] = $dir;
	include("dirsearch.html");
	exit;
}
if ($act == "filesearch") {
	if (isset($_REQUEST["dir"])) {
		$dir = $_REQUEST["dir"];
	} else {
		$dir = getcwd();
		$dir = strtr($dir, "\\", "/");	// Windows対応
	}
	if (isset($_REQUEST["page"])) {
		$page = $_REQUEST["page"];
	} else {
		$page = "0";
	}
	$ary = explode("/", $dir);
	if ($ary[count($ary) - 1] == "..") {
		array_pop($ary);
		array_pop($ary);
		$dir = join("/" , $ary);
	}
	if (!is_dir($dir)) {
		$dir = dirname($dir);
	}
	$h = opendir($dir);
	$dir_list = array();
	$list = array();
	while (($item = readdir($h))) {
		if ($item != ".") {
			if (is_dir($dir . "/" . $item)) {
				$dir_list[] = $item;
			} else {
				$list[] = $item;
			}
		}
	}
	closedir($h);
	//
	if ((count($dir_list) + count($list)) > DIR_MAX) {
		$n = intval(((count($dir_list) + count($list)) + (DIR_MAX - 1)) / DIR_MAX);
		$data["pageng"] = page_index($page, $n);
		$pos = 0;
		$n = 0;
		foreach ($dir_list as $val) {
			if ($pos >= ($page * DIR_MAX)) {
				$data["dir_list"][] = $val;
				$n++;
				if ($n >= DIR_MAX) break;
			}
			$pos++;
		}
		if ($n < DIR_MAX) {
			foreach ($list as $val) {
				if ($pos >= ($page * DIR_MAX)) {
					$data["list"][] = $val;
					$n++;
					if ($n >= DIR_MAX) break;
				}
				$pos++;
			}
		}
	} else {
		$data["list"] = $list;
		$data["dir_list"] = $dir_list;
	}
	$data["page"] = $page;
	$data["dir"] = $dir;
	include("filesearch.html");
	exit;
}
// 共通処理
function page_index($cur, $pages)
{
	$page = array();
	$no = 0;
	if ($cur > 0) {
		$page[$no] = array('no' => $cur - 1, 'name' => '前へ', 'link' => 1);
		$no++;
	}
	for ($i = 0; $i < $pages; $i++) {
		if ($i == $cur) {
			$page[$no] = array('no' => $i, 'name' => $i + 1);
		} else {
			$page[$no] = array('no' => $i, 'name' => $i + 1, 'link' => 1);
		}
		$no++;
	}
	if ($cur < ($pages - 1)) {
		$page[$no] = array('no' => $cur + 1, 'name' => '次へ', 'link' => 1);
		$no++;
	}
	return $page;
}
